﻿Public Class frmMove

    Private speed_codeR(2) As Byte, speed_codeL(2) As Byte, run_dirR As String, run_dirL As String

    Private Sub btnClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClose.Click
        Me.Visible = False
        frmMain.Visible = True
    End Sub

    '前進ボタン　押下げ時の処理
    Private Sub btnFor_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnFor.MouseDown

        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        'トラックバーからスピード設定値を取得
        speed_codeR(0) = TrackBar1.Value
        speed_codeL(0) = TrackBar1.Value

        '進行方向をセット
        run_dirR = "F"
        run_dirL = "F"

        '移動パラメータセット
        roboio_move.send_palam(speed_codeR, speed_codeL, run_dirR, run_dirL)

        '移動開始
        roboio_move.run()

    End Sub

    '後進ボタン　押下げ時の処理
    Private Sub btnBack_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnBack.MouseDown

        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        'トラックバーからスピード設定値を取得
        speed_codeR(0) = TrackBar1.Value
        speed_codeL(0) = TrackBar1.Value

        '進行方向をセット
        run_dirR = "R"
        run_dirL = "R"

        '移動パラメータセット
        roboio_move.send_palam(speed_codeR, speed_codeL, run_dirR, run_dirL)

        '移動開始
        roboio_move.run()

    End Sub

    '左旋回ボタン　押下げ時の処理
    Private Sub btnLeft_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnLeft.MouseDown

        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        'トラックバーからスピード設定値を取得
        speed_codeR(0) = TrackBar1.Value
        speed_codeL(0) = TrackBar1.Value

        '進行方向をセット
        run_dirR = "F"
        run_dirL = "B"

        '移動パラメータセット
        roboio_move.send_palam(speed_codeR, speed_codeL, run_dirR, run_dirL)

        '移動開始
        roboio_move.run()

    End Sub

    '右旋回ボタン　押下げ時の処理
    Private Sub btnRight_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnRight.MouseDown

        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        'トラックバーからスピード設定値を取得
        speed_codeR(0) = TrackBar1.Value
        speed_codeL(0) = TrackBar1.Value

        '進行方向をセット
        run_dirR = "B"
        run_dirL = "F"

        '移動パラメータセット
        roboio_move.send_palam(speed_codeR, speed_codeL, run_dirR, run_dirL)

        '移動開始
        roboio_move.run()

    End Sub

    '前後左右進ボタン　を放した時の処理（ストップする）
    Private Sub btnFor_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnFor.MouseUp, btnBack.MouseUp, btnLeft.MouseUp, btnRight.MouseUp

        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        '移動停止
        roboio_move.terminate()

    End Sub

    '「停止」ボタンの処理
    '指定距離を移動中の中断
    Private Sub btnAbort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAbort.Click

        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        '移動停止
        roboio_move.terminate()

    End Sub

    '「実行」ボタンの処理
    Private Sub btnExe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExe.Click

        Dim move_type(2), move_dir(2) As Byte
        Dim distance As String
        Dim roboio_move As RoboIO_Move
        roboio_move = New RoboIO_Move

        '移動タイプを取得
        move_type(0) = Val(Mid(Me.ComboBox1.Text, 1, 1))

        '移動方向を取得
        move_dir(0) = Val(Mid(Me.ComboBox2.Text, 1, 1))

        '移動距離を取得
        distance = Me.txtDist.Text

        '移動パラメータセット
        roboio_move.move0(move_type, move_dir, distance)

    End Sub
    '移動タイプのコンボボックスが変化したら、それに対応した移動方向や単位に表示を変更する
    Private Sub ComboBox1_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox1.TextChanged

        If Me.ComboBox1.Text = "0-直進　　　（速度制御無し）" Or _
                    Me.ComboBox1.Text = "2-直進" Then

            Me.lblUnit.Text = "mm"

            Me.ComboBox2.Items.Clear()
            Me.ComboBox2.Items.Add("0-後進")
            Me.ComboBox2.Items.Add("1-前進")

            Me.ComboBox2.Text = Me.ComboBox2.Items(1)

        Else

            lblUnit.Text = "deg"

            Me.ComboBox2.Items.Clear()
            Me.ComboBox2.Items.Add("0-左旋回")
            Me.ComboBox2.Items.Add("1-右旋回")

            Me.ComboBox2.Text = Me.ComboBox2.Items(0)

        End If

    End Sub

    Private Sub btnCapture_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCapture.Click

        '変数定義
        Dim buff(64) As Byte
        Dim command_char(64)
        Dim i As Integer


        '*************************************************
        'センサ情報取得コマンド（メイン）
        SIO.write_command("2")

        'センサ情報取得コマンド（サブ）
        frmMain.SerialPort1.Write("0", 0, 1)

        'データ受信
        Do
            '受信完了を待つ
            System.Windows.Forms.Application.DoEvents()
            i = frmMain.SerialPort1.BytesToRead
        Loop Until i = 5

        '受信した画像データをバッファに取り込む
        frmMain.SerialPort1.Read(buff, 0, 5)

        '走行ステータス表示
        i = buff(0)
        Me.txtStatus.Text = Format(i)

        '右エンコーダカウント値の表示
        i = buff(1) * 256 + buff(2)
        Me.txtRight.Text = Format(i)

        '左エンコーダカウント値の表示
        i = buff(3) * 256 + buff(4)
        Me.txtLeft.Text = Format(i)

        '*************************************************
        'センサ情報取得コマンド（メイン）
        SIO.write_command("2")

        'センサ情報取得コマンド（サブ）
        frmMain.SerialPort1.Write("1", 0, 1)

        'データ受信
        Do
            '受信完了を待つ
            System.Windows.Forms.Application.DoEvents()
            i = frmMain.SerialPort1.BytesToRead
        Loop Until i = 3

        '受信した画像データをバッファに取り込む
        frmMain.SerialPort1.Read(buff, 0, 3)

        'ＰＳＤ１生データの表示
        i = buff(0)
        Me.txtPsd1.Text = Format(i)

        'ＰＳＤ２生データの表示
        i = buff(1)
        Me.txtPsd2.Text = Format(i)

        'ＰＳＤ３生データの表示
        i = buff(2)
        Me.txtPsd3.Text = Format(i)

    End Sub
End Class